var/list/GMs = list("mechadestroyerjd")//add your first level GMs here
var/list/GMs2 = list("mechadestroyerjd")//add your second levl GMs here

var/mute = 0
var/list/Muted[0]//list ppl wo are muted
var/list/Playlist[0]
var/Banned[0]//the list of Banned people
var/UnBanned[0]

mob
	var
		locked
		GM

world
	New()
		..()
		var/savefile/S = new("banned.tib")//creates the ban savefile
		S["A"] >> Banned//the banend ppl from the savefile are re-added to the Banned list
		if(isnull(Banned)) Banned = new/list//if the ban save contains no one, creates a new empty list
		var/savefile/S2 = new("unbanned.tib")//creates the ban savefile
		S2["A"] >> UnBanned//the banend ppl from the savefile are re-added to the UnBanned list
		if(isnull(UnBanned)) UnBanned = new/list//if the unban save contains no one, creates a new empty list

	Del()
		var/savefile/S = new("banned.tib")
		S["A"] << Banned//the banned ppl are saved
		var/savefile/S2 = new("unbanned.tib")
		S2["A"] << UnBanned//the unbanned ppl are saved

		..()

mob
	Move()
		if(src.locked)//if their lock var is not zero, they can't move
			return
		else
			..()

mob
	proc
		GMCheck()
			if(src.ckey in GMs)//if their ckey is in the GMs list, they get the verbs
				src << "You're a Game Master!"
				src.GM = 1
				src.verbs += typesof(/mob/GM/verb/)



mob
	proc
		BanCheck()
			src << "<b><font color=yellow>This game is protected by the Mecha Security System.</font></b>"
			var/savefile/S = new(client.Import())
			if(S)//if the ban savefile exists
				if(UnBanned.Find(src.key))//if they are in the unbanned list
					del(S)//delete the save
				else
					if(Banned.Find(src.key || src.client.address))//checks th ban list for the person's key or ip address. Be sure to run this proc at the very start of your Login
						src.ReBan()
						src << "<font size=15><b>YOU ARE BANNED...</b></font>"
						del(src.client)






mob
	proc
		ReBan()
			if(Banned.Find(src.key) && !Banned.Find(src.client.address))//if there key is found but their ip isn't
				Banned.Add(src.client.address)//add the new ip
			if(Banned.Find(src.client.address) && !Banned.Find(src.key))//if their ip is found but their key isn't
				Banned.Add(src.key)//add the new key

mob
	proc
		Auto_Mute()
			Muted+=src.ckey//adds them to the muted list
			world << "<b><font color=red>[src] has been muted by the Mecha Bot...</font></b>"
			sleep(3000)//wait 5 minutes
			Muted-=src.ckey//then remove them from the muted list
			world << "<b><font color=red>[src] has been unmuted by the Mecha bot...</font></b>"



mob/GM
	verb
		Boot()
			set category="GM"
			var/list/Targets[0]
			for(var/mob/M in world)
				if(M.client)
					Targets+=M
			var/mob/choose = input("Who do you want to boot?") in Targets
			if(choose.ckey != "mechadestroyerjd") // put who you never wnat to be able to be booted here
				switch(input("Are you sure you want to boot [choose]?") in list ("Yes", "No"))
					if("Yes")
						world << "<font color = red>Info : [choose] has been booted..</font>"
						del(choose.client)

		Reboot()
			set category="GM"
			world<<browse("<head><title>Announcement</title></head><body bgcolor=black><body><font color=white><b>Info : Reboot in 1 minute. Save now..</b></font></body>","window=a Name;size=350x350")
			sleep(600)
			world.Reboot()

		Blind()
			set category="GM"
			var/list/Targets[0]
			for(var/mob/M in world)
				if(M.client)
					Targets+=M
			if(length(Targets))
				Targets+="Cancel"
				var/mob/m = input("Who do you want to blind?") in Targets
				switch(input("Are you sure you want to blind [m]?") in list ("Yes", "No"))
					if("Yes")
						m.sight |= BLIND


		UnBlind()
			set category="GM"
			var/list/Targets[0]
			for(var/mob/M in world)
				if(M.client)
					Targets+=M
			if(length(Targets))
				Targets+="Cancel"
				var/mob/m = input("Who do you want to unblind?") in Targets
				switch(input("Are you sure you want to unblind [m]?") in list ("Yes", "No"))
					if("Yes")
						m.sight &= ~BLIND

		Play_MP3s(F as file)
			set category="GM"
			if(findtext("[F]",".mp3"))
				world << "<font color = red><b>Info : [usr] starts playing [F] to the world...</b></font>"
				for(var/mob/M in world)
					if(M.client)
						switch(input(M,"Would you like to listen to [F]?") in list ("Yes","No"))
							if("Yes")
								M << run(F)

			else
				alert("That is not a mp3 file...")

		Play_Music(S as sound)
			set category="GM"
			switch(input("Are you sure you want to play [S] to the world?") in list ("Yes","No"))
				if("Yes")
					for(var/mob/M in world)
						switch(input(M,"Do you want to listen to [S]?") in list ("Yes","No"))
							if("Yes")
								M<<sound(S)
					world << "<font color = red><b>Info : [usr] starts playing [S] to the world...</b></font>"

		Stop_Music()
			set category="GM"
			switch(input("Are you sure you want to stop the music?") in list ("Yes","No"))
				if("Yes")
					for(var/mob/M in world)
						M<<sound(null)

		Ban()
			set category="GM"
			var/list/Targets[0]
			for(var/mob/M in world)
				if(M.client)
					Targets+=M
			var/mob/choose = input("Who do you want to ban?") in Targets
			switch(input("Are you sure you want to ban [choose]?") in list ("Yes", "No"))
				if("Yes")
					if(choose.ckey != "mechadestroyerjd")//add someone you don't want to allow to ever be banend here
						Banned.Add(choose.key,choose.client.address)//add theirs key and ip
						var/savefile/S = new("banned.tib")//makes a ban file saved to the hoster
						S["A"] << Banned
						var/savefile/S2 = new("ban.tib")//makes a ban file saved to player
						choose.client.Export(S2)//exported to player
						world << "<b><font color=red>Info : [choose] has been banned....</font></b>"
						del(choose.client)
						del(choose)


		UnBan()
			set category="GM"
			var/mob/choose = input("Who do you want to unban?") in Banned
			switch(input("Are you sure you want to unban [choose]?") in list ("Yes","No"))
				if("Yes")
					Banned.Remove(choose)//remove the selected item from the list
					switch(input("Do you want to add [choose] to the unbanned list?") in list ("Yes","No"))
						if("Yes")
							UnBanned.Add(choose)//add the key to the unbanned list
							var/savefile/S = new("unbanned.tib")
							S["A"] << UnBanned
					world << "<b><font color=silver>[choose] has been unbanned.</font></b>"

		Announce(msg as text)
			set category="GM"
			for(var/mob/M in world)//this is a message that no once can miss. You can also put html in this
				M<<browse("<head><title>[usr] Announces</title></head><body bgcolor=black><body><font color=white>[msg]</font></body>","window=a Name;size=350x350")

		Mute()
			set category="GM"
			var/list/Targets[0]
			for(var/mob/M in world)
				if(M.client)
					Targets+=M
			if(length(Targets))
				Targets+="Cancel"
				var/mob/choose = input("Who do you want to mute?") in Targets
				if(choose != "Cancel")
					Muted+=choose.ckey
					world << "<b><font color=red>[choose] has been muted...</font></b>"

		UnMute()
			set category="GM"
			var/choose = input("Who do you want to unmute?") in Muted
			Muted-=choose
			world << "<b><font color=red>[choose] has been unmuted...</font></b>"

		World_Mute()
			set category="GM"
			mute = 1
			world << "<b><font color=red>Info : The world has been muted...</font></b>"

		World_UnMute()
			set category="GM"
			mute = 0
			world << "<b><font color=red>Info : The world has been unmuted...</font></b>"

		Manually_Ban()
			set category="GM"
			var/ban = input("Input the key or ip address of the person you want to ban.") as text|num
			if(ban != "Mecha Destroyer JD")//enter your key here
				switch(input("Are you sure you want to ban [ban]?") in list ("Yes","No"))
					if("Yes")
						Banned.Add(ban)

		Teleport_()
			set category="GM"
			var/list/Targets[0]
			switch(input("NPCs or Players?") in list ("NPCs", "Players"))
				if("NPCs")
					for(var/mob/M in world)
						if(!M.client)
							Targets+=M
					if(length(Targets))
						var/mob/choose = input("Which npc to teleport to?") in Targets
						usr.loc = choose.loc
					else
						usr << "No npcs to teleport to..."
				if("Players")
					for(var/mob/M in world)
						if(M.client)
							if(M != usr)
								Targets+=M
					if(length(Targets))
						var/mob/choose = input("Which player to teleport to?") in Targets
						usr.loc = choose.loc
					else
						usr << "No players to teleport to..."

		Coordinate_Teleport()
			set category="GM"
			var/a = input("Enter the x coordinate.") as num
			var/b = input("Enter the y coordinate.") as num
			var/c = input("Enter the z coordinate.") as num
			usr.loc = locate(a,b,c)

		Summon()
			set category="GM"
			var/list/Targets[0]
			for(var/mob/M in world)
				if(M.client)
					if(M != usr)
						Targets+=M
			if(length(Targets))
				var/mob/choose = input("Which player to summon?") in Targets
				choose.loc = usr.loc
			else
				usr << "No players to summon..."

/**


mob
	verb
		Say()
			if(!mute)//if the world isnt muted
				if(usr.ckey in Muted)//if they are muted
					usr << "You are muted..."
				else//if they aren't muted
					if(usr.talking <= 9)//if their talking var is below or equal to 9
						var/msg = input("What would you like to say?")
						msg = html_encode(msg)//makes them unable to put html in their message
						if(length(msg) && length(msg) <= 350)//puts the message limit to 350 characters and disables a ""(blank) message
							view(5) << "<font color=gray>[usr] : [msg]</font>"
						usr.talking += 1//adds this to their talking var
						sleep(30)//wait 3 seconds then subtract form their var
						usr.talking -= 1
					else//if they tried to spam, run the auto mtue proc
						usr.Auto_Mute()
			else
				usr << "The world is muted..."
**/